<template>
    <div>
        <slot v-if="clientAuthorised && userAuthorised" />
        <div v-else>Loading...</div>
    </div>
</template>

<script>
import gql from 'graphql-tag'
import config from '../config/config'
import vueObject from './vue-object'

export default {
  name: 'PeWrapper',
  props: ['pwa'],
  provide () {
    return {
      setUser: this.setUser,
      user: this.user,
      refreshUser: this.refreshUser
    }
  },
  data () {
    return {
      userData: { },
      clientAuthorised: false,
      userAuthorised: false
    }
  },
  computed: {
    user () {
      return this.userData
    }
  },
  methods: {
    setUser (user) {
      vueObject(this, this.userData, user)
    },
    async refreshUser () {
      const querySettings = {
        query: gql`
            query {
                userInfo
                {
                    name
                    family_name
                }
            }
        `
      }
      if (!this.pwa) {
        querySettings.fetchPolicy = 'network-only'
        querySettings.errorPolicy = 'network-only'
      }
      let user
      try {
        user = await this.$apollo.query(querySettings)
      } catch (e) {
        window.localStorage.removeItem('user_token')
        window.localStorage.removeItem('client_token')
        window.location.reload()
        return
      }
      this.setUser(user.data.userInfo)
    }
  },
  async mounted () {
    if (!window.localStorage.getItem('client_token')) {
      this.$apollo.mutate({
        mutation: gql`
      mutation token($input: TokenInput){ token(input: $input) {
        access_token
        token_type
        expires_in
        refresh_token
      }}
    `,
        variables:
        {
          input: {
            grant_type: 'jwt-bearer',
            assertion: config.assertion_token
          }
        },
        update: (store, { data: { token } }) => {
          localStorage.setItem(
            'client_token',
            token.access_token
          )
          this.clientAuthorised = true
        }
      })
    } else {
      this.clientAuthorised = true
    }
    if (window.localStorage.getItem('user_token')) {
      await this.refreshUser()
      this.userAuthorised = true
    } else {
      this.userAuthorised = true
    }
  }
}
</script>
